<script>
import SidebarLink from './SidebarLink'
import { collapsed, toggleSidebar, sidebarWidth } from './state'

export default {
  props: {},
  components: { SidebarLink },
  setup() {
    return { collapsed, toggleSidebar, sidebarWidth }
  }
}
</script>

<template>
  <div class="sidebar" :style="{ width: sidebarWidth }">
    <h1>
      <span v-if="collapsed">
        <div>Q</div>
        <div>R</div>
      </span>
      <span v-else>QR CODE Generator</span>
    </h1>
    <!-- <i class="fas fa-qrcode"></i> -->
    <!-- fas fa-home -->
    <!-- <i class="fa-solid fa-wand-magic-sparkles"></i> -->
    <SidebarLink to="/" icon="fas fa-qrcode">Home</SidebarLink>
    <SidebarLink to="/animation" icon="fas fa-magic">Animation</SidebarLink>
    <SidebarLink to="/about" icon="fas fa-question-circle">About</SidebarLink>

    <span
      class="collapse-icon"
      :class="{ 'rotate-180': collapsed }"
      @click="toggleSidebar"
    >
      <i class="fas fa-angle-double-left" />
    </span>
  </div>
</template>

<style>
:root {
  --sidebar-bg-color: #32114d;
  --sidebar-item-hover: #63309c;
  --sidebar-item-active: #803c9bc4;
}

</style>

<style scoped>
.sidebar {
  color: white;
  background-color: var(--sidebar-bg-color);

  float: left;
  position: fixed;
  z-index: 1;
  top: 0;
  left: 0;
  bottom: 0;
  padding: 0.5em;

  transition: 0.3s ease;

  display: flex;
  flex-direction: column;
}

.sidebar h1 {
  height: 2.5em;
}

.collapse-icon {
  position: absolute;
  bottom: 0;
  padding: 0.75em;

  color: rgba(255, 255, 255, 0.7);

  transition: 0.2s linear;
}

.rotate-180 {
  transform: rotate(180deg);
  transition: 0.2s linear;
}
</style>
